package de.jottyfan.minecraft.quickiefabric.blockentity;

import de.jottyfan.minecraft.quickiefabric.blocks.QuickieBlocks;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.util.Tickable;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

/**
 * 
 * @author jotty
 *
 */
public class DrillBlockDownEntity extends BlockEntity implements Tickable {

	private static final Integer MAXDRILLSTEP = 20;
	private Integer drillstep;

	public DrillBlockDownEntity() {
		super(QuickieFabricBlockEntity.DRILL_DOWN);
	}

	protected static final void moveBlockWithEntity(BlockPos from, BlockPos to, World world) {
		BlockEntity be = world.getBlockEntity(from);
		BlockState bs = world.getBlockState(from);
		if (be != null) {
			world.setBlockState(from, Blocks.AIR.getDefaultState());
			world.setBlockState(to, bs);
			world.removeBlockEntity(from);
			world.setBlockEntity(to, be);
		}
	}

	protected static final void drill(BlockPos pos, BlockPos to, World world) {
		if (!world.getBlockState(to).isOf(Blocks.BEDROCK) && !world.getBlockState(to).isOf(QuickieBlocks.DRILLSTOP)) {
			world.breakBlock(to, true);
			if (pos.down() != to) { // no need for the falling one
				moveBlockWithEntity(pos, to, world);
			}
		}
	}


	@Override
	public void tick() {
		drillstep = drillstep == null ? MAXDRILLSTEP : drillstep - 1;
		if (drillstep < 1) {
			drillstep = MAXDRILLSTEP;
			drill(getPos(), getPos().down(), getWorld());
		}
	}
}
