package de.jottyfan.minecraft.quickiefabric.blockentity;

import java.util.Random;

import de.jottyfan.minecraft.quickiefabric.blocks.QuickieBlocks;
import de.jottyfan.minecraft.quickiefabric.items.QuickieItems;
import net.minecraft.block.Blocks;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.entity.ItemEntity;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Tickable;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

/**
 * 
 * @author jotty
 *
 */
public class EmptyLavaHoarderBlockEntity extends BlockEntity implements Tickable {

	public EmptyLavaHoarderBlockEntity() {
		super(QuickieFabricBlockEntity.EMPTYLAVAHOARDER);
	}

	/**
	 * sucks the lava that touches the block
	 * 
	 * @param world the world
	 * @param pos   the pos
	 * @return true if lava was found
	 */
	private boolean suckLava(World world, BlockPos pos) {
		if (world == null) {
			return false;
		} else if (Blocks.LAVA.equals(world.getBlockState(pos).getBlock())) {
			world.setBlockState(pos, Blocks.AIR.getDefaultState());
			BlockPos up = pos.up();
			Random random = new Random();
			if (random.nextFloat() > 0.9f) {
				world.spawnEntity(new ItemEntity(world, up.getX(), up.getY(), up.getZ(),
						new ItemStack(QuickieItems.SULPHOR, 1 + new Random().nextInt(4))));
			}
			return true;
		}
		return false;
	}

	@Override
	public void tick() {
		BlockPos pos = getPos();
		World world = getWorld();
		boolean found = suckLava(world, pos.north());
		found = found || suckLava(world, pos.south());
		found = found || suckLava(world, pos.east());
		found = found || suckLava(world, pos.west());
		found = found || suckLava(world, pos.up());
		found = found || suckLava(world, pos.down());
		if (found) {
			world.setBlockState(pos, QuickieBlocks.LAVAHOARDER.getDefaultState());
		}
	}
}
