package de.jottyfan.minecraft.quickiefabric.blockentity;

import java.util.List;

import net.minecraft.block.entity.BlockEntity;
import net.minecraft.entity.Entity;
import net.minecraft.entity.mob.HostileEntity;
import net.minecraft.util.Tickable;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Box;
import net.minecraft.world.World;

/**
 * 
 * @author jotty
 *
 */
public class MonsterHoarderBlockEntity extends BlockEntity implements Tickable {

	private float suckradius;
	
	public MonsterHoarderBlockEntity() {
		super(QuickieFabricBlockEntity.MONSTERHOARDER);
		suckradius = 8f; // TODO: make it level up - able and start with 2
	}

	@Override
	public void tick() {
		BlockPos pos = getPos();
		World world = getWorld();
		Box box = new Box(pos).expand(suckradius);
		List<Entity> entities = world.getOtherEntities(null, box);
		for (Entity entity : entities) {
			if (entity instanceof HostileEntity) {
				HostileEntity mobEntity = (HostileEntity) entity;
				mobEntity.setOnFireFor(90);
			}
		}
	}
}
