package de.jottyfan.minecraft.quickiefabric.tools.externalmods;

import java.util.HashSet;
import java.util.Set;

import net.minecraft.util.Identifier;

/**
 * 
 * @author jotty
 *
 */
public class Byg extends Identifier {

	public static final IdentifierGroups WOOD = new IdentifierGroups("aspen", "baobab", "blue_enchanted", "cherry",
			"cika", "cypress", "ebony", "fir", "green_enchanted", "holly", "jacaranda", "mahogany", "mangrove", "pine",
			"rainbow_eucalyptus", "redwood", "skyris", "willow", "witch_hazel", "zelkova");
	public static final IdentifierGroups MUSHROOM = new IdentifierGroups("blue_glowshroom", "purple_glowshroom",
			"red_glowshroom", "yellow_glowshroom");

	/**
	 * create identifier preluded by byg (for biomes you'll go)
	 * 
	 * @param id the id within byg
	 */
	public Byg(String id) {
		super("byg", id);
	}

	/**
	 * create a new set of Byg Identifiers
	 * 
	 * @param names the names
	 * @return a set of identifiers
	 */
	public static final Set<Identifier> createFromStrings(String... names) {
		Set<Identifier> set = new HashSet<>();
		for (String name : names) {
			set.add(new Byg(name));
		}
		return set;
	}

	/**
	 * create from groups
	 * 
	 * @param groups the groups
	 * @return the set of indentifier groups
	 */
	public static final Set<IdentifierGroup> createFromGroups(IdentifierGroup... groups) {
		Set<IdentifierGroup> set = new HashSet<>();
		for (IdentifierGroup group : groups) {
			group.setModId("byg");
			set.add(group);
		}
		return set;
	}

	/**
	 * create from set
	 * 
	 * @param set the set
	 * @return the set of idenfifier groups
	 */
	public static final Set<IdentifierGroup> createFromSet(Set<IdentifierGroup> set) {
		for (IdentifierGroup group : set) {
			group.setModId("byg");
		}
		return set;
	}
}
