package de.jottyfan.minecraft.quickiefabric.tools.externalmods;

import java.util.HashSet;
import java.util.Set;

import net.minecraft.util.Identifier;

/**
 * 
 * @author jotty
 *
 */
public class IdentifierGroup {
	private final Set<String> names;
	private String modId;
	
	public IdentifierGroup(String prefix, String... suffix) {
		this.names = new HashSet<>();
		for (String s : suffix) {
			names.add(new StringBuilder(prefix).append("_").append(s).toString());
		}
	}
	
	/**
	 * get the identifiers for the mod
	 * 
	 * @return the set of identifiers
	 */
	public Set<Identifier> getIdentifiers(){
		Set<Identifier> set = new HashSet<>();
		for (String name : names) {
			set.add(new Identifier(modId, name));
		}
		return set;
	}

	public String getModId() {
		return modId;
	}

	public void setModId(String modId) {
		this.modId = modId;
	}
}
