package de.jottyfan.minecraft.quickiefabric.tools.externalmods;

import java.util.HashSet;
import java.util.Set;

/**
 * 
 * @author jotty
 *
 */
public class IdentifierGroups {

	private final Set<IdentifierGroup> groups;
	private final String[] prefixes;
	
	public IdentifierGroups(String... prefixes) {
		this.prefixes = prefixes;
		groups = new HashSet<>();
	}
	
	private void fillGroups(String... suffixes) {
		for (String prefix : prefixes) {
			groups.add(new IdentifierGroup(prefix, suffixes));
		}
	}
	
	public Set<IdentifierGroup> getGroups(String... suffixes){
		fillGroups(suffixes);
		return groups;
	}
}
