package de.jottyfan.minecraft.quickiefabric.tools.externalmods;

import java.util.HashSet;
import java.util.Set;

import net.minecraft.util.Identifier;

/**
 * 
 * @author jotty
 *
 */
public class Terrestria extends Identifier {

	public static final IdentifierGroups WOOD = new IdentifierGroups("cypress", "hemlock", "japanese_maple",
			"rainbow_eucalyptus", "redwood", "rubber", "sakura", "willow", "yucca_palm");

	/**
	 * create identifier preluded by terrestria
	 * 
	 * @param id the id within terrestria
	 */
	public Terrestria(String id) {
		super("terrestria", id);
	}

	/**
	 * create a new set of Terrestria Identifiers
	 * 
	 * @param names the names
	 * @return a set of identifiers
	 */
	public static final Set<Identifier> createFromStrings(String... names) {
		Set<Identifier> set = new HashSet<>();
		for (String name : names) {
			set.add(new Terrestria(name));
		}
		return set;
	}

	/**
	 * create from groups
	 * 
	 * @param groups the groups
	 * @return the list of indentifier groups
	 */
	public static final Set<IdentifierGroup> createFromGroups(IdentifierGroup... groups) {
		Set<IdentifierGroup> set = new HashSet<>();
		for (IdentifierGroup group : groups) {
			group.setModId("terrestria");
			set.add(group);
		}
		return set;
	}

	/**
	 * create from set
	 * 
	 * @param set the set
	 * @return the set of idenfifier groups
	 */
	public static final Set<IdentifierGroup> createFromSet(Set<IdentifierGroup> set) {
		for (IdentifierGroup group : set) {
			group.setModId("terrestria");
		}
		return set;
	}

}
